using API.Controllers;
using API.Dto;
using Microsoft.AspNetCore.Mvc;
using System.Collections.Generic;

namespace TestProject1
{
    public class Tests
    {
        [SetUp]
        public void Setup()
        {
        }

        /*private readonly IDataManager datamanager;
        public DemoController(IDataManager datamanager)
        {
            this.datamanager = datamanager;
        }*/

        [Test]
        public void TestGET()
        {
            //Arrange

            //Act
            var championResult = ChampionController.get();

            //Assert
            var objectResult = championResult as OkObjectResult;
            //vrifie que cest un ok 200 et un objet
            Assert.IsNotNull(objectResult);

            var champions = objectResult?.value as IEnumerable<ChampionDto>;
            Assert.IsNotNull(champions);

            Assert.AreEqual(champions.count(), (await stubData.championsMgr.getItems(0, 5)).Count());
        }

        [Test]
        public void TestPOST()
        {
            //Arrange
            var championDto = new ChampionDto()
            {
                Name = "Darius"
            };

            //Act
            var championResult = await ChampionController.post(championDto);

            //Assert
            var objectResult = championResult as CreatedAtActionResult;
            Assert.IsNotNull(objectResult);

            var champions = objectResult?.value as ChampionDto;
            Assert.IsNotNull(champions);

        }

   
    }
}